SystemOrganization addCategory: #Either!

Object subclass: #Either
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Either'!

!Either class methodsFor: 'monad' stamp: 'fbs 7/6/2011 12:20'!
return
	^ [:x | Right value: x].! !

!Either class methodsFor: 'monad' stamp: 'fbs 7/6/2011 12:19'!
return: anObject
	^ self return value: anObject! !

!Either class methodsFor: 'instance creation' stamp: 'fbs 7/1/2011 13:51'!
value: anObject
	^ self new value: anObject! !

!Either methodsFor: 'testing' stamp: 'fbs 7/1/2011 13:57'!
isRight
	self subclassResponsibility! !

!Either methodsFor: 'accessing' stamp: 'fbs 7/1/2011 13:50'!
value
	^ value! !

!Either methodsFor: 'private' stamp: 'fbs 7/1/2011 13:51'!
value: anObject
	value := anObject.! !

Either subclass: #Left
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Either'!

!Left methodsFor: 'comparing' stamp: 'fbs 7/6/2011 17:31'!
= anObject
	^ anObject isRight not and: [anObject value = value].! !

!Left methodsFor: 'monad' stamp: 'fbs 7/1/2011 14:04'!
>>= anEitherReturningUnaryBlock
	^ self.! !

!Left methodsFor: 'testing' stamp: 'fbs 7/1/2011 13:55'!
isRight
	^ false.! !

!Left methodsFor: 'printing' stamp: 'fbs 7/6/2011 17:25'!
printOn: aStream
	aStream nextPutAll: 'Left '.
	value printOn: aStream.! !

Either subclass: #Right
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Either'!

!Right methodsFor: 'comparing' stamp: 'fbs 7/6/2011 17:28'!
= anObject
	^ anObject isRight and: [anObject value = value].! !

!Right methodsFor: 'monad' stamp: 'fbs 7/1/2011 14:07'!
>>= anEitherReturningUnaryBlock
	^ anEitherReturningUnaryBlock value: value! !

!Right methodsFor: 'testing' stamp: 'fbs 7/1/2011 13:57'!
isRight
	^ true.! !

!Right methodsFor: 'printing' stamp: 'fbs 7/6/2011 17:25'!
printOn: aStream
	aStream nextPutAll: 'Right '.
	value printOn: aStream.! !
